/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/



function boxtheclown(request, context, inputStream, offset, count) {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot) {
		LOG("In function boxtheclown::onDataAvailable, received the call to die!\n");
		return; }

	LOG("In boxtheclown, cancelling the callwrapper.\n");
		
	req = this.parent;
	req.callwrapper.cancel();

	var ref_url = req.reqURL;
	LOG("In function boxtheclown::onDataAvailable, ref_url is equal to " + ref_url + "\n");

	var Iid = ref_url.substring(ref_url.indexOf("Iid=")+4);
	LOG("In function boxtheclown::onDataAvailable, Iid is equal to " + Iid + "\n");

	var the_pic = "http://www.boxtheclown.com/btc_1.aspx?Iid=" + Iid;
	LOG("In function boxtheclown::onDataAvailable, the_pic is equal to: " + the_pic + "\n");

	req.baseFileName = Iid + ".jpg";
	LOG("In function boxtheclown::onStartRequest, fixing to start the download\n");
	doStartDownload(req, the_pic);
	}



function boxclown_Listener() {
	this.parent = new Object();
	this.request = new Object();
	}

boxclown_Listener.prototype = {
	onStartRequest : function(request) {
		this.request = request;
		},
	onStopRequest : function() {},
	onDataAvailable : function() {},
	abort : function() {
		this.request.cancel(-1);
		}
	}



function boxclown_init() {
	LOG("Entering function requestObj.init with uniqID of: " + this.uniqID + "\n");
	LOG(this.uniqID + ": curThread is equal to: " + this.cp.curThread + "\n");
	
	LOG("In boxclown_init, removing session cookie.\n");
	var cookie_killer = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
	cookie_killer.remove("www.boxtheclown.com", "ASP.NET_SessionId", "/", false);

	var self = this;  // avoid loss of scope
	
	if(self.cp.curThread >= maxThreads)	{
		LOG("In function requestObj.init with uniqID of: " + this.uniqID + ", curThread >= maxThreads\n");
		return;
		}	
	if(self.finished || self.inprogress) {
		LOG("In function requestObj.init with uniqID of: " + this.uniqID + 
		    "\nfinished: " + self.finished + ", inprogress: " + self.inprogress + "\n");
		return;
		}

	try {
		var retry_dick = "(" + String(maxRetries - self.retryNum + 1) + " of " + String(maxRetries) + ")";

		updateDownloadProgress(null, self.uniqID, self.reqURL, null, "Re-Starting HTTP Request..." + retry_dick);
		}
	catch(e) {
		var m = self.curLinkNum + 1;
		var page_stat = "Page " + self.pageNum + ": " + m + " of " + self.totLinkNum;
		addDownloadProgress(page_stat, self.uniqID, self.reqURL, "Starting HTTP Request...");
		}

	self.cp.curThread++;
	self.inprogress = true;

	var req_timeout = reqTimeout;  // timeout is in milliseconds

	self.hostFunc = self.regexp;

	self.callwrapper = new CCallWrapper(self, req_timeout, 'retry');
	CCallWrapper.asyncExecute(self.callwrapper);

	delete(self.xmlhttp);
	self.xmlhttp = new boxclown_Listener();
	self.xmlhttp.onDataAvailable = self.hostFunc;
	self.xmlhttp.parent = self;

	var someChannel = ioService.newChannel(self.reqURL,null,null);
	someChannel.asyncOpen(self.xmlhttp, null);

	LOG("Exiting function requestObj.init with uniqID of:" + self.uniqID + "\n");
	}