/*
 * CCallWrapper.js
 * $Revision: 1.3 $ $Date: 2003/07/07 18:32:43 $
 */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Netscape code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Corporation.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Bob Clary <bclary@netscape.com>
 *
 * ***** END LICENSE BLOCK ***** */

function CCallWrapper(aObjectReference, aDelay, aMethodName, aReqId)
{
  this.mId = 'CCallWrapper_' + (CCallWrapper.mCounter++);
  LOG("Initializing new CCallWrapper object with mId of " + this.mId + " and reqID of " + aReqId + "\n");
  this.mObjectReference = aObjectReference;
  this.mDelay     = aDelay;
  this.mTimerId = 0;
  this.mMethodName = aMethodName;
  this.mReqId = aReqId;
  CCallWrapper.mPendingCalls[this.mId] = this;
}

CCallWrapper.prototype.execute = function()
{
  var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
  if (toDieOrNot) return;

  var req = this.mObjectReference;
  var retry_dick = "(" + String(maxRetries - req.retryNum + 1) + " of " + String(maxRetries) + ")";

  LOG("CCallWrapper with mId of " + this.mId + " and reqID of " + this.mReqId + " has timed out.  Executing the passed function\n");
  this.mObjectReference[this.mMethodName]();
  delete CCallWrapper.mPendingCalls[this.mId];
};

CCallWrapper.prototype.cancel = function()
{
  LOG("CCallWrapper object with mId of " + this.mId + " and reqID of " + this.mReqId + " cancelled.\n");
  clearTimeout(this.mTimerId);
  delete CCallWrapper.mPendingCalls[this.mId];
};

CCallWrapper.asyncExecute = function (/* CCallWrapper */ callwrapper)
{
  LOG("asyncExecute called in CCallWrapper with mId of " + callwrapper.mId + " and reqID of " + callwrapper.mReqId + "\n");
  CCallWrapper.mPendingCalls[callwrapper.mId].mTimerId = setTimeout('CCallWrapper.mPendingCalls["' + callwrapper.mId + '"].execute()', callwrapper.mDelay);
};

CCallWrapper.mCounter = 0;
CCallWrapper.mPendingCalls = {};
