/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




function clearFromWin(reqID) {
	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	LOG("In " + myself + ", reqID: " + reqID + "\n");

	var doc = ig_dl_win.document;
	var autoClear = doc.getElementById("cbAutoClear").checked;

	if (!autoClear) return;

	var outBox = doc.getElementById("outBox");
	var treeItem = doc.getElementById(reqID);

	outBox.removeChild(treeItem);

	var reqs = ig_dl_win.req_objs;

	try {
		for (var i = 0; i < reqs.length; i++)
			if (reqs[i].uniqID == reqID) reqs.splice(i, 1);

		delete reqs[reqID];

		ig_dl_win.req_objs = setUpLinkedList(reqs);
		}
	catch(e) {}

	var cache_file = new CacheFileService("dlWin_cache");
	//cache_file.writeCache(req_objs.toSource());
	LOG("Exiting " + myself + "\n");
}


function addDownloadProgress(page_stat, some_id, fName, status_text) {
	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var doc = ig_dl_win.document;

	//try {	ig_dl_win.req_objs[some_id].status = status_text; }
	//catch(e) { throw "IHG error: couldn't write status to req_objs in addDownloadProgress"; }

	var outBox = doc.getElementById("outBox");
	var treeItem = doc.createElement("treeitem");
	treeItem.setAttribute("id", some_id);

	var treeRow = doc.createElement("treerow");
	
	var treeCell0 = doc.createElement("treecell");
	treeCell0.setAttribute("label", page_stat);
	treeCell0.setAttribute("id", "page_stat_" + some_id);

	var treeCell1 = doc.createElement("treecell");
	treeCell1.setAttribute("label", fName);
	treeCell1.setAttribute("id", "fname_" + some_id);

	var treeCell2 = doc.createElement("treecell");
	treeCell2.setAttribute("mode", "normal");
	treeCell2.setAttribute("value", "0");
	treeCell2.setAttribute("id", "prog_met_" + some_id);

	var treeCell3 = doc.createElement("treecell");
	treeCell3.setAttribute("label", status_text);
	treeCell3.setAttribute("id", "stat_text_" + some_id);

	treeRow.appendChild(treeCell0);
	treeRow.appendChild(treeCell1);
	treeRow.appendChild(treeCell2);
	treeRow.appendChild(treeCell3);
	treeItem.appendChild(treeRow);
	outBox.appendChild(treeItem);

	LOG("Exiting " + myself + "\n");
}


/* first arg is the request id, or the id of the object you are trying to add.
 * the rest of the args are optional... they correspond to the fields that
 * are to be updated.  A null value will result in nothing being set for that
 * column.
 */
function updateDownloadProgress(page_stat, some_id, fname, progress, status) {
	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var doc = ig_dl_win.document;

	//try {	ig_dl_win.req_objs[some_id].status = status; }
	//catch(e) { throw "IHG error: couldn't write status to req_objs in updateDownloadProgress"; }

	
	if (page_stat) {
		var pStat = doc.getElementById("page_stat_" + some_id);
		if (!pStat) throw "IHG error: pStat is null in updateDownloadProgress";
		pStat.setAttribute("label", page_stat);
		}

	if (fname) {
		var fName = doc.getElementById("fname_" + some_id);
		if (!fName) throw "IHG error: fName is null in updateDownloadProgress";
		fName.setAttribute("label", fname);
		}

	if (progress) {
		var progMet = doc.getElementById("prog_met_" + some_id);
		if (!progMet) throw "IHG error: progMet is null in updateDownloadProgress";
		progMet.setAttribute("value", String(progress));
		}

	if (status) {
		var statText = doc.getElementById("stat_text_" + some_id);
		if (!statText) throw "IHG error: statText is null in updateDownloadProgress";
		statText.setAttribute("label", status);
		}

	LOG("Exiting " + myself + "\n");
	}


function updateDownloadStatus(someText) {
	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var doc = ig_dl_win.document;

	var statLabel = doc.getElementById("statLabel");
	statLabel.value = someText;
	}