/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




// CacheFileService constructor
//
// cacheFileID: a string representing the file

function CacheFileService(cacheFileID) {
	if (!cacheFileID) throw "IHG error: cacheFileID is null in CacheFileService";

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var id = "{E4091D66-127C-11DB-903A-DE80D2EFDFE8}"; // imagegrabber's ID
	var cacheFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	// This should work for Firefox v1.5+  It returns a file object initialized
	// with the path where the extension is located
	try {
		cacheFile = Components.classes["@mozilla.org/extensions/manager;1"]
	      	    .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id); 
		}
	// For those who are still using the antiquated Firefox versions
	catch(e) {
		cacheFile = Components.classes["@mozilla.org/file/directory_service;1"]
			    .getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		cacheFile.append("extensions");
		cacheFile.append(id);
		}


	cacheFile.append("cache");
	if(!cacheFile.exists()) cacheFile.create(1,0755);

	cacheFile.append(cacheFileID);

	this.cacheFile = cacheFile;
	this.fout = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

	this.SIS = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	}

CacheFileService.prototype = {
	writeCache : function cache_writeCache(someStuff, append_or_not) {	// set to false to overwrite; default is false
		if(!someStuff) throw "IHG error: someStuff is null in cache_writeCache";

		var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
		LOG("Entering " + myself + "\n");

		var f_perms = 0755;  // this is ignored on windows
		var f_flags = 0x02 | 0x08;

		if(append_or_not) f_flags |= 0x10;
		else f_flags |= 0x20;

		var count = someStuff.length;

		this.fout.init(this.cacheFile, f_flags, f_perms, null);
		
		this.fout.write(someStuff, count);
		this.fout.close();
	},

	getCache : function cache_getCache() {
		if( !this.cacheFile.exists() ) return null;

		var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
		LOG("Entering " + myself + "\n");

		var fileURI = ioService.newFileURI(this.cacheFile);
		var channel = ioService.newChannelFromURI(fileURI);

		var stream = channel.open();

		var count = stream.available();
		this.SIS.init(stream);
		var shitty = this.SIS.read(count);			

		return shitty;
		}
	}




function forumStyleFileService() {
	var id = "{E4091D66-127C-11DB-903A-DE80D2EFDFE8}"; // imagegrabber's ID
	var forumStyleFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	// This should work for Firefox v1.5+  It returns a file object initialized
	// with the path where the extension is located
	try {
		forumStyleFile = Components.classes["@mozilla.org/extensions/manager;1"]
      		    .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id); 
		}
	// For those who are still using the antiquated Firefox versions
	catch(e) {
		forumStyleFile = Components.classes["@mozilla.org/file/directory_service;1"]
			    .getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		forumStyleFile.append("extensions");
		forumStyleFile.append(id);
		}

	forumStyleFile.append("forum_styles.xml");
	this.forumStyleFile = forumStyleFile;
	}


forumStyleFileService.prototype = {
	getForumStyles : function forum_getForumStyles() {
		if( !this.forumStyleFile.exists() ) return null;

		var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
		LOG("Entering " + myself + "\n");

		var fileURI = ioService.newFileURI(this.forumStyleFile);

		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);
		
		return req.responseXML;
		}
	}


function HostFileService() {
	var id = "{E4091D66-127C-11DB-903A-DE80D2EFDFE8}"; // imagegrabber's ID
	var hostFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	if(hostFileLoc != "") {
		hostFile.initWithPath(hostFileLoc);
		var fuckwhore = hostFile.exists();
		if (!fuckwhore) hostFileLoc = "";
		}

	if(hostFileLoc == "") {
		// This should work for Firefox v1.5+  It returns a file object initialized
		// with the path where the extension is located
		try {
			hostFile = Components.classes["@mozilla.org/extensions/manager;1"]
	      		    .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id); 
			}
		// For those who are still using the antiquated Firefox versions
		catch(e) {
			hostFile = Components.classes["@mozilla.org/file/directory_service;1"]
				    .getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
			hostFile.append("extensions");
			hostFile.append(id);
			}

		hostFile.append("hostf.xml");
		}

	this.hostFile = hostFile;
	}


HostFileService.prototype = {
	getHosts : function host_getHosts() {
		if( !this.hostFile.exists() ) return null;

		var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
		LOG("Entering " + myself + "\n");

		var fileURI = ioService.newFileURI(this.hostFile);

		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);
		
		return req.responseXML;
		}
	}




function dlWinCacheService(cacheFileID) {
	if (!cacheFileID) throw "IHG error: cacheFileID is null in dlWinCacheService";

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var id = "{E4091D66-127C-11DB-903A-DE80D2EFDFE8}"; // imagegrabber's ID
	var cacheFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	try {
		cacheFile = Components.classes["@mozilla.org/extensions/manager;1"]
	      	    .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id); 
		}
	catch(e) {
		cacheFile = Components.classes["@mozilla.org/file/directory_service;1"]
			    .getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		cacheFile.append("extensions");
		cacheFile.append(id);
		}

	cacheFile.append("cache");
	if(!cacheFile.exists()) cacheFile.create(1,0755);

	cacheFile.append(cacheFileID);

	this.cacheFile = cacheFile;
	}


dlWinCacheService.prototype = {
	writeCache : function dlWin_writeCache(req_objs) {
		var newDocument = Components.classes["@mozilla.org/xml/xml-document;1"].createInstance(Components.interfaces.nsIDOMXMLDocument);
		var newRoot = newDocument.createElement("root");


		for(var i = 0; i < req_objs.length; i++) { 
			var newReqObj = newDocument.createElement("reqObj");
			newReqObj.setAttribute("id", "req_" + i);

			for (var j in req_objs[i]) { 
				var x = typeof(req_objs[i][j]); 
				if ( (x != "object" && x != "function") || j == "regexp" ) {
					var newProp = newDocument.createElement("prop");
					newProp.setAttribute("id", j + "_" + i);
					newProp.setAttribute("type", x);

					if (req_objs[i][j].toString().match(/function/)) newProp.appendChild(newDocument.createCDATASection(req_objs[i][j]));
					else newProp.appendChild(newDocument.createTextNode(req_objs[i][j]));

					newReqObj.appendChild(newDocument.createTextNode("\n"));
					newReqObj.appendChild(newProp);
					//newReqObj.appendChild(newDocument.createTextNode("\n"));
					}
				}

			newRoot.appendChild(newDocument.createTextNode("\n")); 
			newRoot.appendChild(newReqObj); 
			newRoot.appendChild(newDocument.createTextNode("\n"));
			}

		newDocument.appendChild(newRoot);

		var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
		persist.persistFlags = persist.PERSIST_FLAGS_NO_CONVERSION | persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES | persist.PERSIST_FLAGS_BYPASS_CACHE;
		persist.saveDocument(newDocument, this.cacheFile, null, null, null, null);
	},

	getCache : function dlWin_getHosts() {
		if( !this.cacheFile.exists() ) return null;

		var fileURI = ioService.newFileURI(this.cacheFile);

		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);
		
		return req.responseXML;
		}
	}
