/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/


function getPicById(req) {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot && !req.override_stop) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var refURL = req.reqURL;
	var theID = req.regexp.match(/ID: (.+)/)[1];

	var curSource = getImgSrcById(req.xmlhttp.responseText , theID);
	if(!curSource) return null;

	var someURI = ioService.newURI(refURL, null, null);
	var the_url = someURI.resolve(curSource);

	return the_url;
	}


function getPicByRegExp(req) {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot && !req.override_stop) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var refURL = req.reqURL;
	var regexp = new RegExp(req.regexp);

	var imageElems = getImgTags(req.xmlhttp.responseText);
	var the_url = "";

	for (var n = 0; n < imageElems.length; n++) {
		var curSource = getImgSrcFromTag(imageElems[n]);
		if (curSource) {
			if (imageElems[n].match(req.regexp)) {
				var someURI = ioService.newURI(refURL, null, null);
				the_url = someURI.resolve(curSource);
				}
			}
		}
	return the_url;
	}


function genericHostFunc() {
	var req = this.parent;
	req.callwrapper.cancel();

	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot && !req.override_stop) return;

	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var pageData = this.responseText;
	var pageUrl = req.reqURL;

	if(typeof(req.regexp) == "function") {
		var retVal = req.regexp(pageData, pageUrl);

		if (retVal.fileName) req.baseFileName = retVal.fileName;
		if (retVal.referer) req.referer = retVal.referer;

		if (retVal.status == "OK") {
			var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	
			var someURI = ioservice.newURI(pageUrl, null, null);
			var the_url = someURI.resolve(retVal.imgUrl);
			}

		if (retVal.status == "ABORT") {
			req.abort("Can't find image on page!");
			return;
			}

		if (retVal.status == "RETRY") {
			if (retVal.imgUrl) {
				req.reqURL = retVal.imgUrl;
				req.retryNum++;
				}
			req.retry();
			return;
			}

		if (retVal.status == "REQUEUE") {
			var newPageUrl = retVal.imgUrl;
			var newHostFunc = getHostToUse(newPageUrl);
			if(!newHostFunc) {
				updateDownloadStatus("Can't find new host function");
				throw "IHG error: can't find new host function for requeue in genericHostFunc";
				}

			req.regexp = newHostFunc;

			req.reqURL = newPageUrl;
			req.retryNum++;

			req.retry();
			return;
			}
		}

	else if(typeof(req.regexp) == "string") {
		if(req.regexp.match(/ID: .+/)) {
			var the_url = getPicById(req);
			}
		else if(req.regexp.match(/REPLACE: .+/)) {
			var tempMatch = req.regexp.match(/REPLACE: ('|")(.*)\1.*,.*('|")(.*)\3/);
			var the_url = req.reqURL.replace( new RegExp(tempMatch[2]), tempMatch[4] );
			}
		else var the_url = getPicByRegExp(req);

		if(!the_url) {
			req.abort("Can't find image on page!");
			return;
			}
		}

	else { throw "IHG error: the regexp value is not a string or function for " + req.uniqID; }

	LOG("In " + myself + ", fixing to start download\n");
	doStartDownload(req, the_url);
	}



function getHostToUse(innerLink) {
	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + " with innerLink of: " + innerLink + "\n");

	if (!unsep_list) {
		var hostFileObj = new HostFileService();
		var hFile = hostFileObj.getHosts();
		var hosts = hFile.getElementsByTagName("host");
		unsep_list = "";

		for (i=0; i<hosts.length; i++) {
			var uPatNode = hosts[i].getElementsByTagName("urlpattern")[0];
			var uPat = "if (innerLink.match(/" + uPatNode.textContent + "/)) { ";

			var sPatNode = hosts[i].getElementsByTagName("searchpattern")[0];
			var sPat = "retval = " + sPatNode.textContent + "; }";
			unsep_list += uPat + sPat + "\n\r";
			}
		}

	var retval = false;
	eval(unsep_list);

	return retval;
	}