/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




/* function hostGrabber:
 *
 * Takes one parameter: 
 * docLinks:		a multi-dimensional array of strings where the first dimension
 *				represents the first page and the second dimension represents
 *				all the links for that page
 *
 * If docLinks is null (such is the case if you don't use the thread sucker), then the
 * function will create a docLinks and fill it with the links on the current page.  Also,
 * it will be assumed that suckMode is false if docLinks is null.
 *
 * Returns nothing.
 *
 */
function hostGrabber(docLinks) {
	LOG("Entering function hostGrabber.\n");
	if(!docLinks) {
		suckMode = false;

		// Initialize variables if not already initialized
		var feelItRex = initVars();
		if (!feelItRex) {
			LOG("In hostGrabber, call to function initVars failed for some reason.\n");
			return;
			}

		var docLinks = new Array();

		docLinks[firstPage] = new Array();

		for (var q = 0; q < content.document.links.length; q++) {
			docLinks[firstPage][q] = content.document.links[q].href;
			}
		}
	LOG("In hostGrabber, docLinks is equal to: " + docLinks.toSource() + "\n");

	if (unsep_list != "") unsep_list = "";

	var time = new Date();
	var x = time.getTime();

	var objLinks = setUpLinksOBJ(docLinks);

	var tmp_req_objs = setUpReq(objLinks);
	tmp_req_objs = setUpLinkedList(tmp_req_objs);

	var time = new Date();
	var y = time.getTime();

	// Uncomment this line to get benchmark results
	//alert((y-x)/1000);

	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) {
		ig_dl_win = ig_dl_win_obj.openWindow(null, "chrome://imagegrabber/content/interfaces/downloads.xul", "ig-dl_win", "resizable,scrollbars=yes", null);
		ig_dl_win.req_objs = tmp_req_objs;

		ig_dl_win.onload = finishUp;
		}
	else {
		if (ig_dl_win.req_objs) {
			var new_array = Array.concat(ig_dl_win.req_objs, tmp_req_objs);
			for(i=0; i < new_array.length; i++)	new_array[new_array[i].uniqID] = new_array[i];
			delete ig_dl_win.req_objs;
			new_array = setUpLinkedList(new_array);
			ig_dl_win.req_objs = new_array;
			}
		else ig_dl_win.req_objs = tmp_req_objs;

		var doc = ig_dl_win.document;
		var supPop = doc.getElementById("cbSupPop").checked;

		if (!supPop) ig_dl_win.focus();
		finishUp(tmp_req_objs);
		}
	} //end of hostGrabber function


function finishUp(req_objs) {
	// if this is the event for the window load, re-assign the variable
	// pick something from the event class to identify it as an event
	// the member "type" is sufficient
	if (req_objs.type) req_objs = this.req_objs;

	//var cache_file = new CacheFileService("dlWin_cache");
	//if (cacheDLWin) cache_file.writeCache(req_objs.toSource());

	updateDownloadStatus("Running....");

	for(var i = 0; i < req_objs.length; i++) {
		var m = req_objs[i].curLinkNum + 1;
		var page_stat = "Page " + req_objs[i].pageNum + ": " + m + " of " + req_objs[i].totLinkNum;
		addDownloadProgress(page_stat, req_objs[i].uniqID, req_objs[i].reqURL, "Waiting...");
		}


	// This means it found no links
	if (req_objs.length == 0) return;
	for (var i = 0; i < (req_objs.length<maxThreads?req_objs.length:maxThreads); i++) req_objs[i].init();
	}



function showDLWin() {
	initVars(true); // true to suppress directory selection dialog
	var req_objs = getDLCache();

	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) {
		ig_dl_win = ig_dl_win_obj.openWindow(null, "chrome://imagegrabber/content/interfaces/downloads.xul", "ig-dl_win", "resizable,scrollbars=yes", null);
		ig_dl_win.req_objs = req_objs;

		ig_dl_win.onload = function () {
			for(var i = 0; i < req_objs.length; i++) {
				var m = req_objs[i].curLinkNum + 1;
				var page_stat = "Page " + req_objs[i].pageNum + ": " + m + " of " + req_objs[i].totLinkNum;
				addDownloadProgress(page_stat, req_objs[i].uniqID, req_objs[i].reqURL, req_objs[i].status);
				updateDownloadProgress(null, req_objs[i].uniqID, null, (req_objs[i].curProgress / req_objs[i].maxProgress) * 100, null);
				}

			};
		}
	else {
		ig_dl_win.focus();
		return;
		}
	}


function getDLCache() {
	var dlCache = new dlWinCacheService("dlwin_cache");
	var cacheDoc = dlCache.getCache();

	var reqList = cacheDoc.getElementsByTagName("reqObj");
	var req_objs = new Array();
	for (var h = 0; h < reqList.length; h++) {
		req_objs[h] = new requestObj();
		var props = reqList[h].getElementsByTagName("prop");
		for (var i = 0; i < props.length; i++) { 
			var propType = props[i].getAttribute("type");

			var propName = props[i].getAttribute("id");
			propName = propName.match(/(.+)_\d+/)[1];

			if (propType == "function") eval("var propValue = " + props[i].textContent);
			else if (propType == "string") var propValue = props[i].textContent;
			else if (propType == "number") var propValue = parseInt(props[i].textContent);
			else if (propType == "boolean") {
				if (props[i].textContent == "true") var propValue = true;
				else var propValue = false;
				}

			req_objs[h][propName] = propValue;
			req_objs[h].hostFunc = genericHostFunc;
			req_objs[h].debugLog();
			}
		req_objs[h].inprogress = false;
		req_objs[req_objs[h].uniqID] = req_objs[h];
		}

	req_objs = setUpLinkedList(req_objs);
	return req_objs;
	}



/* function setUpLinksOBJ:
 *
 * Takes one parameter:
 * docLinks:		a multi-dimensional array of strings where the first dimension
 *				represents the first page and the second dimension represents
 *				all the links for that page
 *
 * Returns an object of the LinksOBJ class.
 *
 */
function setUpLinksOBJ(docLinks) {
	var objLinks = new LinksOBJ();
	var dateString = getFormattedDate();

	for (var i = firstPage; i <= lastPage; i++) {
		var t_count = 0;

		objLinks.links[i] = new Array();
		objLinks.dirSave[i] = new Array();
		objLinks.hostFunc[i] = new Array();

		for (var j = 0; j < docLinks[i].length; j++) {
			// gets rid of the anonymizers
			var tmpMatch = docLinks[i][j].match(/http:\/\/.+\/\?(http:\/\/.+)/);
			if(tmpMatch) docLinks[i][j] = tmpMatch[1];

			var theHostFunc = getHostToUse(docLinks[i][j]);
			if (theHostFunc) {
				objLinks.hostFunc[i][t_count] = theHostFunc;
				objLinks.links[i][t_count] = docLinks[i][j];

				// Create an instance of the local file object
				var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				aFile.initWithPath(baseDirSave);

				// Create a directory for the doc title if option is set
				if (createDocTitSF) aFile.append((prefix_directories?(dateString + "_"):"") + docTitle);

				// Create a directory for each page if in suck mode
				if (suckMode) {
					if (createPageDirs) aFile.append("Page" + i);
					}

				var doesDirExist = aFile.exists();
				if (!doesDirExist) aFile.create(1,0755); // 1 for directory, 0 for file
				objLinks.dirSave[i][t_count] = aFile.path;

				t_count++;
				} //end of if statement

			} // end of inner-for loop

		} // end of outer-for loop

	return objLinks;
	} //end of function




/* function setUpReq:
 *
 * Takes one parameter:
 * objLinks:	An object of the LinkOBJ class.  
 *
 * Returns an array of request objects. 
 *
 */
function setUpReq(objLinks) {
	var temp_array = new Array()
	var count = 0;

	for(var i = firstPage; i <= lastPage; i++) {
		var fName = getFormattedDate();

		for(var j = 0; j < objLinks.links[i].length; j++) {
			var inner_link = objLinks.links[i][j];
			var dir_save = objLinks.dirSave[i][j];
			var host_func = objLinks.hostFunc[i][j];
			
			var req = new requestObj();

			req.regexp = host_func;
			req.hostFunc = genericHostFunc;
				
			req.reqURL = inner_link;
			req.dirSave = dir_save;
			req.retryNum = maxRetries;
			req.pageNum = i;
			req.curLinkNum = j;
			req.totLinkNum = objLinks.links[i].length;
			req.uniqID = "req_" + Math.round(Math.random() * 1e9);
			req.uniqFN_prefix = fName;

			//if (inner_link.match(/boxtheclown/)) req.init = boxclown_init;

			req.debugLog();

			temp_array[count] = req;
			temp_array[req.uniqID] = temp_array[count];
			count++;
			} // end of inner-for loop
		} // end of outer-for loop

	return temp_array;
	} // end of function


/* function setUpLinkedList:
 *
 * Takes one parameter:
 * req_objs:	An array of objects of the requestObj class
 *
 * Returns an array of objects of the requestObj class.
 *
 * The purpose of this function is to set up the linked list
 * for the requestObj class.  In this case, links are refering
 * to other objects and not to html links.
 *
 */
function setUpLinkedList(req_objs) {
	var lastObj = req_objs.length - 1;

	for(var i = 0; i < req_objs.length; i++) {
		if (i == 0) req_objs[i].previousRequest = null;
		else req_objs[i].previousRequest = req_objs[i-1];

		if (i == lastObj) req_objs[i].nextRequest = null;
		else req_objs[i].nextRequest = req_objs[i+1];

		req_objs[i].firstRequest = req_objs[0];
		req_objs[i].lastRequest = req_objs[lastObj];
		}

	return req_objs;
	}
	


/* LinksOBJ class constructor:
 *
 * links:	 	a multi-dimensional array of strings.  The first dimension represents 
 * 			the page number.  The second dimension represents the links belonging 
 *			to that page. 
 *
 * dirSave:		a multi-dimensional array of strings.  The first dimension represents 
 *			the page number.  The second dimension represents the directory where 
 *			the image will be saved.
 *
 * hostFunc:	a multi-dimensional array of functions.  The first dimension represents
 *			the page number.  The second dimension an actual function that will be 
 * 			used to handle the requests.
 *
 */
function LinksOBJ() {
	this.links = new Array();
	this.dirSave = new Array();
	this.hostFunc = new Array();
	}



////////////////////////  Get imagegrabber preferences  ////////////////////////
function getIGPrefs() {
var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
LOG("Entering " + myself + "\n");

var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

showDLDir = prefManager.getBoolPref("extensions.imagegrabber.showdldir");
LOG("In " + myself + ", showDLDir is equal to: " + showDLDir + "\n");

try {
	lastDLDir = prefManager.getCharPref("extensions.imagegrabber.lastdldir");
	}
catch(err) {
	prefManager.setCharPref("extensions.imagegrabber.lastdldir", "");
	}

LOG("In " + myself + ", lastDLDir is equal to: " + lastDLDir + "\n");

AUTO_RENAME = prefManager.getBoolPref("extensions.imagegrabber.autorename");
LOG("In " + myself + ", AUTO_RENAME is equal to: " + AUTO_RENAME + "\n");

fileExistsBehavior = prefManager.getCharPref("extensions.imagegrabber.fileexistsbehavior");
LOG("In " + myself + ", fileExistsBehavior is equal to: " + fileExistsBehavior + "\n");

maxThreads = prefManager.getIntPref("extensions.imagegrabber.maxthreads");
LOG("In " + myself + ", maxThreads is equal to: " + maxThreads + "\n");

maxRetries = prefManager.getIntPref("extensions.imagegrabber.numretries");
LOG("In " + myself + ", maxRetries is equal to: " + maxRetries + "\n");

reqTimeout = prefManager.getIntPref("extensions.imagegrabber.requesttimeout");
reqTimeout *= 1000;
LOG("In " + myself + ", reqTimeout is equal to: " + reqTimeout + "\n");

createDocTitSF = prefManager.getBoolPref("extensions.imagegrabber.createdoctitlesubfolder");
LOG("In " + myself + ", createDocTitSF is equal to: " + createDocTitSF + "\n");

createPageDirs = prefManager.getBoolPref("extensions.imagegrabber.createpagedirs");

prefManager.setBoolPref("extensions.imagegrabber.killmenow", false);

hostFileLoc = prefManager.getCharPref("extensions.imagegrabber.hostfileloc");
LOG("In " + myself + ", hostFileLoc is equal to: " + hostFileLoc + "\n");

prefix_fileNames = prefManager.getBoolPref("extensions.imagegrabber.prefixfilenames");
LOG("In " + myself + ", prefix_fileNames is equal to: " + prefix_fileNames + "\n");

prefix_directories = prefManager.getBoolPref("extensions.imagegrabber.prefixdirectories");
LOG("In " + myself + ", prefix_directories is equal to: " + prefix_directories + "\n");

cacheDLWin = prefManager.getBoolPref("extensions.imagegrabber.cachedlwin");
LOG("In " + myself + ", cacheDLWin is equal to: " + cacheDLWin + "\n");

LOG("Exiting " + myself + "\n");
}



//////////////////////   Initiliaze the variables //////////////////////////
function initVars(skipDirDialog) {
var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
LOG("Entering " + myself + "\n");

var doc = content.document;
docTitle = doc.title.replace(/[\\/:*?"<>|,]/g, '').replace(/\./g,'').replace(/ - Mozilla Firefox$/,'');

if (docTitle.length > 89) docTitle = docTitle.substring(0, 89);

docTitle = docTitle.replace(/\s+$/, '');

LOG("In " + myself + ", about to call getIGPrefs().\n");
getIGPrefs();

if (showDLDir && !skipDirDialog) {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	LOG("In " + myself + ", about to get baseDirSave\n");

	baseDirSave = setDownloadDir("Enter base download folder", lastDLDir);
	if (!baseDirSave) {
		LOG("In " + myself + ", user cancelled the request.\n");
		return false; }
	prefManager.setCharPref("extensions.imagegrabber.lastdldir", baseDirSave);
	}
else baseDirSave = lastDLDir;
LOG("In " + myself + ", baseDirSave is equal to: " + baseDirSave + "\n");

if (suckMode) {
	LOG("In " + myself + ", setting suckMode variables.\n");

	firstPage = parseInt(prompt("Enter first page:",""));
	if (!firstPage) {
		LOG("In " + myself + ", user cancelled the request.\n");
		return false; }

	lastPage = parseInt(prompt("Enter last page:",""));
	if (!lastPage) {
		LOG("In " + myself + ", user cancelled the request.\n");
		return false; }

	if (firstPage > lastPage)
		{
		alert("the first page number, " + firstPage + ", is greater than last page number, " + lastPage);
		LOG("In " + myself + ", quitting because firstPage > lastPage.\n");
		return false;
		}
	}
else {
	firstPage=getCurPageNum();
	LOG("In " + myself + ", firstPage is equal to: " + firstPage + "\n");
	lastPage=firstPage;
	}

LOG("Exiting " + myself + "\n");
return true;
}