/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/





///////////////////////////////   Get the current page number //////////////////////////
function getCurPageNum() {
	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var getCurP;
	var doc = content.document;
	var classElems = doc.getElementsByTagName('td');
	
	for (var i=0; i < classElems.length; i++)
		{
		var tmpClass = classElems[i].getAttribute('class');
		if (tmpClass)
			{
			if (tmpClass.match(/vbmenu_control/))
				{
				var classHTML = classElems[i].innerHTML;
				if (classHTML.match(/Page [0-9]+ of [0-9]+/))
					{
					// The regexp remembers the first number and stores it
					// in the element 1 of the array
					getCurP = classHTML.match(/Page ([0-9]+) of [0-9]+/);
					}
				}
			}
		}
	LOG("In " + myself + ", getCurP is equal to: " + getCurP + "\n");
	if (!getCurP) return 1;
	return getCurP[1];
}




/////////////////  Gets the last page number ////////////////////////
function getLastPageNum() {
	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var getLastP;
	var doc = content.document;
	var classElems = doc.getElementsByTagName('td');
	
	for (var i=0; i < classElems.length; i++)
		{
		var tmpClass = classElems[i].getAttribute('class');
		if (tmpClass)
			{
			if (tmpClass.match(/vbmenu_control/))
				{
				var classHTML = classElems[i].innerHTML;
				if (classHTML.match(/Page [0-9]+ of [0-9]+/))
					{
					// The regexp remembers the search for the number in the parenthesis
					// and stores it in element 1 of the array
					getLastP = classHTML.match(/Page [0-9]+ of ([0-9]+)/);
					}
				}
			}
		}
	LOG("In " + myself + ", getLastP is equal to: " + getLastP + "\n");
	if (!getLastP) return 1;
	return getLastP[1];
}


function getFormattedDate() {
	var rightNow = new Date();
	var month = rightNow.getMonth().toString();
	var date = rightNow.getDate().toString();
	var hours = rightNow.getHours().toString();
	var minutes = rightNow.getMinutes().toString();
	var seconds = rightNow.getSeconds().toString();
	var milliseconds = rightNow.getMilliseconds().toString();

	if (month.length < 2) month = "0" + month;
	if (date.length < 2) date = "0" + date;
	if (hours.length < 2) hours = "0" + hours;
	if (minutes.length < 2) minutes = "0" + minutes;
	if (seconds.length < 2) seconds = "0" + seconds;
	while (milliseconds.length < 3) milliseconds = "0" + milliseconds;

	var someString = month + date + hours + minutes + seconds + milliseconds;

	return someString;
	}


function setDownloadDir(FpTitle, initDir) {
	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

	if(fp==null) {
		LOG("In " + myself + ", nsIFilePicker failed to instantiate.\n");
		return false;
		}

	try {
		if (!FpTitle) var FpTitle="Pick a download folder";
		
		try {
			if (initDir) {
				LOG("In " + myself + ", initDir is equal to: " + initDir + "\n");
				var aLocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				aLocalFile.initWithPath(initDir);
				fp.displayDirectory = aLocalFile;
				}
			}
		catch(ex) { LOG("In " + myself + ", could not initialize with a directory\n"); }

		fp.init(top.window, FpTitle, nsIFilePicker.modeGetFolder);
  		var res = fp.show();
		if (res == nsIFilePicker.returnOK) {
  			if (fp.file && (fp.file.path.length > 0)) return fp.file.path;
    			}
		return false;
  		}

  	catch(ex) {
		LOG("In " + myself + ", caught exception: " + ex + "\n");
   		return false;
  		}
	} 





function generateFName(reqObj, URLFile) { 
	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var desiredFName = reqObj.baseFileName;

	// Check to make sure the URLFile is a valid link
	try {
		var pic_uri = ioService.newURI(URLFile,null,null);
		var pic_url = pic_uri.QueryInterface(Components.interfaces.nsIURL);
		}
	catch(e) {
		LOG("In " + myself + ", an invalid URL was given: " + URLFile + "\n");
		return null;
		}

 	// Check to make sure URLFile contains a file
	if(!pic_url.fileName) {
		LOG("In " + myself + ", no file found in URL: " + URLFile + "\n");
		return null;
		}

	// if a desired filename is given, use it
	if(desiredFName) var displayName = desiredFName;

	// otherwise, use the filename from above
	else {
		// If the picture URL is actually a script with some extra stuff at
		// the end (that stuff should uniquely identify the image, hopefully)
		// then we'll use the extra stuff as identifying data for the filename.
		if (pic_url.fileName.match(/(?:jpg|jpeg|bmp|gif|png)$/i)) var displayName = pic_url.fileName;
		else if (pic_url.param) var displayName = pic_url.fileName + pic_url.param;
		else if (pic_url.query) var displayName = pic_url.fileName + pic_url.query;
		else if (pic_url.ref) var displayName = pic_url.fileName + pic_url.ref;
		else var displayName = pic_url.fileName;

  		}

	if (displayName) {
		if (!displayName.match(/(?:jpg|jpeg|bmp|gif|png|flv)$/i))
			displayName += ".jpg";
		}

	// if we still haven't got a file name to use, make a random one to use
	if (!displayName) displayName = Math.random().toString().substring(2) + ".jpg";

	// remove characters from the file name that causes trouble with file system (windows or nsiFile, who knows)
	displayName = displayName.replace(/[\\/:*?"<>|,]/g, '');

	LOG("In " + myself + ", displayName is equal to: " + displayName + "\n");

	LOG("In " + myself + ", AUTO_RENAME is equal to: " + AUTO_RENAME + "\n");
	if (AUTO_RENAME) {
		// does anyone even read this shit?  if so, email me: cybormatt@gmail.com
		// I really should get a life...

		var reqUrl = reqObj.reqURL;
		if (reqUrl.match(/imagevenue/) || reqUrl.match(/fapomatic/)) {
			var indxVal = displayName.indexOf("_");
			if (indxVal != -1) displayName = displayName.substr(indxVal+1);
			LOG("In " + myself + ", displayName is equal to: " + displayName + "\n");
			}
		}

	if (prefix_fileNames) {
		var formatted = "";
		var totLength = reqObj.totLinkNum.toString().length;
		var curLength = reqObj.curLinkNum.toString().length;
		for (j=0; j < totLength - curLength; j++) formatted += "0";
		formatted += reqObj.curLinkNum;
		displayName = reqObj.uniqFN_prefix + "_" + formatted + "_" + displayName;
		}

	// the regex splits the full file name into the main file name and the extension
	var tempVar = displayName.match(/(.+)\.(jpg|jpeg|bmp|gif|png|flv)$/i);

	// if the main file name is longer than 89 chars, then shorten it
	if(tempVar[1].length > 89)
		displayName = tempVar[1].substring(0, 85) + Math.random().toString().substring(2,6) + "." + tempVar[2];

	return displayName;
}



function doStartDownload(reqObj, URLFile) {
	var myself = String(arguments.callee).match(/(function.*)\(.*\)[\n\s]*{/m)[1];
	LOG("Entering " + myself + "\n");

	var dir = reqObj.dirSave;
	var refURL = reqObj.reqURL;


	// if a reference URL was given, set up a new URI object for it
	if (refURL) var ref_uri = ioService.newURI(refURL,null,null);
	else var ref_uri = null;
	LOG("In " + myself + ", refURL: " + refURL + " , ref_uri: " + ref_uri + "\n");

	// initialize the pic uri object
	var pic_uri = ioService.newURI(URLFile,null,null);


	// Get the file name to use
	if (reqObj.retried && reqObj.fileName) var displayName = reqObj.fileName;
	else var displayName = generateFName(reqObj, URLFile);
	if (!displayName) throw "IHG Error: in doStartDownload, can not get displayName";



	// Initiate the local file object 
	var aLocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile); 
	try {
		aLocalFile.initWithPath(dir); 
		}
	catch(e) {
		updateDownloadProgress(null, reqObj.uniqID, null, null, "Failed to initialize File. Skipping!");
		LOG("In " + myself + ", something went wrong with initiating the local file.\n");
		LOG("URLFile: " + URLFile + " , dir: " + dir + " , refURL: " + refURL + "\n");
		LOG("displayName: " + displayName + "\n");
		return;
		}
	aLocalFile.append(displayName);



	// Actions to do if the target file already exists
	if (fileExistsBehavior == "rename" && !reqObj.overwrite) {
		// This causes files to not overwrite themselves.  It's good... trust me
		var notExist = false;
		while (aLocalFile.exists()) {
			indxVal = displayName.lastIndexOf(".");
			displayName = displayName.substr(0, indxVal) + "_01" + displayName.substr(indxVal);
			LOG("In " + myself + ", displayName is equal to: " + displayName + "\n");
			aLocalFile.initWithPath(dir);
			aLocalFile.append(displayName);
			}
		}
	else if (fileExistsBehavior == "skip" && aLocalFile.exists() && !reqObj.overwrite) {
		updateDownloadProgress(null, reqObj.uniqID, aLocalFile.leafName, 100, "File already exists!  Skipping.");
		LOG("File already exists for " + URLFile + ".  Skipping....\n");

		reqObj.finished = true;
		reqObj.inprogress = false;

		reqObj.queueHandler();
		return;
		}
	LOG("In " + myself + ", aLocalFile.path is equal to: " + aLocalFile.path + "\n");



	// Determine if we should resume a download or start from scratch
	if (reqObj.curProgress > 0 && reqObj.maxProgress > 0) var write_mode = "a";
	else var write_mode = "w";
	if (reqObj.maxProgress > 0) {
		if (!aLocalFile.exists()) throw "IHG error: in doStartDownload, file to resume no longer exists";
		var startPos = aLocalFile.fileSize;
		}
	else var startPos = 0;


	// Set up the stream/progress listener
	var aListener = StreamToFile(aLocalFile, write_mode);
	aListener.refURL = refURL;
	aListener.reqObj = reqObj;
	aListener.aFile = aLocalFile;


	// Make a new resumable channel
	var aResChan = ioService.newChannelFromURI(pic_uri);
	if (!reqObj.notResumable) aResChan.QueryInterface(Components.interfaces.nsIResumableChannel);
	aResChan.QueryInterface(Components.interfaces.nsIHttpChannel);


	// tell that channel to resumt at the given byte position
	if (!reqObj.notResumable && startPos != 0) aResChan.resumeAt(startPos, "");

	// assign the listener from above to the notification callback property
	// this is what handles the incoming data
	aResChan.notificationCallbacks = aListener;

	// assign the referrer uri
	aResChan.referrer = ref_uri;

	// and finally, open the channel,
	// providing the same listener to handle the start/stop events
	LOG("In " + myself + ", about to save the URI.\n");
	aResChan.asyncOpen(aListener, null);
  
	LOG("Exiting " + myself + "\n");
	return 0;
	}





function StreamToFile(file, writeMode) {
	var output = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var buffer = Components.classes["@mozilla.org/network/buffered-output-stream;1"].createInstance(Components.interfaces.nsIBufferedOutputStream);

	if (writeMode == "a" || writeMode == "A") output.init(file, 0x02 | 0x10, 0664, null);
	else output.init(file, 0x02 | 0x08 | 0x20, 0664, null);

	buffer.init(output, 8192);

	return new ProgressListener(buffer);	
	}