/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/



function saveSession() {
	var cacheFile = new dlWinCacheService("dlwin_cache");
	cacheFile.writeCache(req_objs);
	}


function reset_retryCount() {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var maxRetries = prefManager.getIntPref("extensions.imagegrabber.numretries");

	var outBox = document.getElementById("outBox");
	var tree = outBox.parentNode;

	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();

	var daNodes = new Array();

	for (var t = 0; t < numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v = start.value; v <= end.value; v++) daNodes.push(tree.view.getItemAtIndex(v));
		}

	for (var s = 0; s < daNodes.length; s++) {
		var idx = daNodes[s].id;
		req_objs[idx].retryNum = maxRetries;
		}
}


function restart_child() {
	var outBox = document.getElementById("outBox");
	var tree = outBox.parentNode;

	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();

	var daNodes = new Array();

	for (var t = 0; t < numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v = start.value; v <= end.value; v++) daNodes.push(tree.view.getItemAtIndex(v));
		}

	for (var s = 0; s < daNodes.length; s++) {
		var idx = daNodes[s].id;
		req_objs[idx].curProgress = 0;
		req_objs[idx].maxProgress = 0;
		req_objs[idx].retryNum++;
		req_objs[idx].overwrite = true;
		req_objs[idx].override_stop = true;
		req_objs[idx].retry();
		}
}

function remove_child() {
	var outBox = document.getElementById("outBox");
	var tree = outBox.parentNode;

	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();

	var daNodes = new Array();

	var removeList = new Array();
	var z = 0;

	var k = 0;
	for (var t = 0; t < numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v = start.value; v <= end.value; v++){
			daNodes[k] = tree.view.getItemAtIndex(v);
			k++;
  			}
		}

	for (var i = 0; i < daNodes.length; i++) {
		outBox.removeChild(daNodes[i]);
		removeList[z++] = daNodes[i].id;
		}

	try {
		req_objs.sort();

		for (var i = 0; i < removeList.length; i++) {
			delete req_objs[removeList[i]];
			for (var j = 0; j < req_objs.length; j++) {
				if (req_objs[j].uniqID == removeList[i]) {
					delete req_objs[j];
					req_objs.sort();
					req_objs.pop();
					break;
					}
				}
			}

		setUpLinkedList();
		}
	catch(e) {}

	var cache_file = new CacheFileService("dlWin_cache");
	//cache_file.writeCache(req_objs.toSource());
	}


function abort_child() {
	var outBox = document.getElementById("outBox");
	var tree = outBox.parentNode;

	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();

	var daNodes = new Array();

	for (var t = 0; t < numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v = start.value; v <= end.value; v++) daNodes.push(tree.view.getItemAtIndex(v));
		}

	for (var s = 0; s < daNodes.length; s++) {
		var idx = daNodes[s].id;
		req_objs[idx].abort();
		}

	}


function retry_child() {
	var outBox = document.getElementById("outBox");
	var tree = outBox.parentNode;

	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();

	var daNodes = new Array();

	for (var t = 0; t < numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v = start.value; v <= end.value; v++) daNodes.push(tree.view.getItemAtIndex(v));
		}

	for (var s = 0; s < daNodes.length; s++) {
		var idx = daNodes[s].id;
		req_objs[idx].retryNum++;
		req_objs[idx].overwrite = true;
		req_objs[idx].override_stop = true;
		req_objs[idx].retry();
		}
	}

function autoClearForm() {
	var autoClear = document.getElementById("cbAutoClear").checked;

	if (autoClear) clear_form();
}

function clear_form() {
	var outBox = document.getElementById("outBox");

	var removeList = new Array();
	var z = 0;

	for (var i = 0; i < req_objs.length; i++) {
		try {
			var daNode = document.getElementById(req_objs[i].uniqID);
			var someShit = daNode.nodeName;
			}
		catch(e) { continue; }

		if(req_objs[i].finished == true && req_objs[i].aborted == false) {
			outBox.removeChild(daNode);
			removeList[z++] = req_objs[i].uniqID;
			}
		}

	try {
		req_objs.sort();

		for (var i = 0; i < removeList.length; i++) {
			delete req_objs[removeList[i]];
			for (var j = 0; j < req_objs.length; j++) {
				if (req_objs[j].uniqID == removeList[i]) {
					delete req_objs[j];
					req_objs.sort();
					req_objs.pop();
					break;
					}
				}
			}

		setUpLinkedList();
		}
	catch(e) {}

	var cache_file = new CacheFileService("dlWin_cache");
	//cache_file.writeCache(req_objs.toSource());
	}

function killme() {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	prefManager.setBoolPref("extensions.imagegrabber.killmenow", true);

	var statLabel = document.getElementById("statLabel");
	statLabel.value = "Stopping the program..........";

	var shit = document.getElementById("outBox");

	for(var i=0; i < shit.childNodes.length; i++) { 
		var idx = shit.childNodes[i].id; 
		if(req_objs[idx].inprogress) {
			req_objs[idx].stopped = true;
			req_objs[idx].abort();
			}
		}
	}


function reviveme() {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	prefManager.setBoolPref("extensions.imagegrabber.killmenow", false);

	var maxThreads = prefManager.getIntPref("extensions.imagegrabber.maxthreads");

	var statLabel = document.getElementById("statLabel");
	statLabel.value = "Reviving the program..........";

	for(var i=0; i < req_objs.length; i++) {
		if(req_objs[i].stopped) {
			req_objs[i].stopped = false;
			req_objs[i].finished = false;
			req_objs[i].aborted = false;
			}
		}

	for (var i = 0; i < (req_objs.length<maxThreads?req_objs.length:maxThreads); i++) req_objs[i].init();
}

function view_details() {
	var igTree = document.getElementById("igTree");
	var idx = igTree.view.selection.currentIndex;
	var daNode = igTree.view.getItemAtIndex(idx);
	var shit = daNode.id;

	var detail_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	var detail_win = detail_win_obj.openWindow(null, "chrome://imagegrabber/content/interfaces/req_details.xul", "ig-detail_win", "resizable,scrollbars=yes", null);
	detail_win.reqObj = req_objs[shit];
	detail_win.addEventListener("load", rightOn, false);
	}

function rightOn() {
	var detail_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	var detail_win = detail_win_obj.getWindowByName("ig-detail_win", null);
	var reqObj = detail_win.reqObj;

	detail_win.document.getElementById("uniqID").value = reqObj.uniqID;
	detail_win.document.getElementById("pageNum").value = reqObj.pageNum;
	detail_win.document.getElementById("totLinkNum").value = reqObj.totLinkNum;
	detail_win.document.getElementById("curLinkNum").value = reqObj.curLinkNum;
	detail_win.document.getElementById("reqURL").value = reqObj.reqURL;
	detail_win.document.getElementById("regexp").value = reqObj.regexp;
	detail_win.document.getElementById("dirSave").value = reqObj.dirSave;
	detail_win.document.getElementById("readyState").value = reqObj.xmlhttp.readyState;
	detail_win.document.getElementById("statusText").value = reqObj.xmlhttp.statusText;
	detail_win.document.getElementById("responseText").value = reqObj.xmlhttp.responseText;
	}




function launchFile() {	
	var igTree = document.getElementById("igTree");
	var idx = igTree.view.selection.currentIndex;
	var daNode = igTree.view.getItemAtIndex(idx);
	var shit = daNode.id;

	if (req_objs[shit].fileName == "") {
		alert("No file to open yet!");
		return;
		}

	var aLocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	aLocalFile.initWithPath(req_objs[shit].dirSave);
	aLocalFile.append(req_objs[shit].fileName);

	aLocalFile.launch();
	}


function setUpLinkedList() {
	var lastObj = req_objs.length - 1;

	for(var i = 0; i < req_objs.length; i++) {
		if (i == 0) req_objs[i].previousRequest = null;
		else req_objs[i].previousRequest = req_objs[i-1];

		if (i == lastObj) req_objs[i].nextRequest = null;
		else req_objs[i].nextRequest = req_objs[i+1];

		req_objs[i].firstRequest = req_objs[0];
		req_objs[i].lastRequest = req_objs[lastObj];
		}
	}