/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var hosts;
var hFile;
var hostFileObj;

function HostFileService() {
	var id = "{E4091D66-127C-11DB-903A-DE80D2EFDFE8}"; // imagegrabber's ID
	var hostf_servers = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	// This should work for Firefox v1.5+  It returns a file object initialized
	// with the path where the extension is located
	try {
		hostf_servers = Components.classes["@mozilla.org/extensions/manager;1"]
      		    .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id); 
		}
	// For those who are still using the antiquated Firefox versions
	catch(e) {
		hostf_servers = Components.classes["@mozilla.org/file/directory_service;1"]
			    .getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		hostf_servers.append("extensions");
		hostf_servers.append(id);
		}

	hostf_servers.append("hostf_servers.xml");

	this.hostf_servers = hostf_servers;
	}


HostFileService.prototype = {
	writeHosts : function cache_writeCache() {
		var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
		persist.persistFlags = persist.PERSIST_FLAGS_NO_CONVERSION | persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES | persist.PERSIST_FLAGS_BYPASS_CACHE;
		persist.saveDocument(hFile, this.hostf_servers, null, null, null, null);
	},

	getHostf_servers : function() {
		if( !this.hostf_servers.exists() ) return null;

		var fileURI = ioService.newFileURI(this.hostf_servers);

		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);
		
		return req.responseXML;
		}

	}


function initWindow() {
	window.addEventListener("resize", resizeResponseTextBox, false);
	//resizeResponseTextBox();
	loadHostFile();
	}

function resizeResponseTextBox() {
	var rBoxThing = document.getElementById("tb_searchPattern");
	rBoxThing.height = window.innerHeight - 100;
	}


function loadHostFile() {
	hostFileObj = new HostFileService();
	hFile = hostFileObj.getHostf_servers();
	hosts = hFile.getElementsByTagName("server");

	var outBox = document.getElementById("tb_searchPattern");

	for (i=0; i < hosts.length; i++) {
		var someThing = outBox.appendItem(hosts[i].textContent);
		someThing.setAttribute("ondblclick", "updateHFile();");
		}
	}

function updateHFile() {
	var tot = document.getElementById("tb_searchPattern");

	var tmpVal = prompt('Enter Host File Server:', tot.selectedItem.label); 
	if(!tmpVal) return;

	var sList = hFile.firstChild.childNodes;

	for(i=0; i<sList.length; i++) {
		if (sList[i].textContent == tot.selectedItem.label) sList[i].textContent = tmpVal;
		}

	tot.selectedItem.label = tmpVal;
	}

function addHostFServer() {
	var newHost = prompt("Enter a new host file server:");
	if(!newHost) return;

	var tmp = hFile.createElement("server");
	tmp.textContent = newHost;

	hFile.firstChild.appendChild(tmp);

	var outBox = document.getElementById("tb_searchPattern");
	var someThing = outBox.appendItem(hosts[i].textContent);
	someThing.setAttribute("ondblclick", "var tmpVal = prompt('Enter Host File Server:', this.label); if(tmpVal) this.label = tmpVal;");
	}

function delHostFServer() {
	var tot = document.getElementById("tb_searchPattern");

	for(i=0; i<hFile.firstChild.childNodes.length; i++) { 
		if (hFile.firstChild.childNodes[i].textContent == tot.selectedItem.label) hFile.firstChild.removeChild(hFile.firstChild.childNodes[i])
		}

	tot.removeItemAt(tot.selectedIndex);
}

function updateHostFile() {
	hostFileObj.writeHosts();
	}
