/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var hosts;
var hFile;
var hostFileObj;
var hostFileLoc = "";

function HostFileService() {
	var id = "{E4091D66-127C-11DB-903A-DE80D2EFDFE8}"; // imagegrabber's ID
	var hostFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	var hostf_servers = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	if(hostFileLoc != "") {
		hostFile.initWithPath(hostFileLoc);
		var fuckwhore = hostFile.exists();
		if (!fuckwhore) hostFileLoc = "";
		}

	// This should work for Firefox v1.5+  It returns a file object initialized
	// with the path where the extension is located
	try {
		hostf_servers = Components.classes["@mozilla.org/extensions/manager;1"]
      		    .getService(Components.interfaces.nsIExtensionManager).getInstallLocation(id).getItemLocation(id); 
		if(hostFileLoc == "") hostFile.initWithPath(hostf_servers.path);
		}
	// For those who are still using the antiquated Firefox versions
	catch(e) {
		hostf_servers = Components.classes["@mozilla.org/file/directory_service;1"]
			    .getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		hostf_servers.append("extensions");
		hostf_servers.append(id);
		if(hostFileLoc == "") hostFile.initWithPath(hostf_servers.path);
		}

	if(hostFileLoc == "") hostFile.append("hostf.xml");
	hostf_servers.append("hostf_servers.xml");

	this.hostf_servers = hostf_servers;
	this.hostFile = hostFile;
	}


HostFileService.prototype = {
	writeHosts : function host_writeCache() {
		var newRoot = hFile.createElement("root");
		var newHosts = new Array();

		for (i=0; i < hosts.length; i++) newHosts[i] = hosts[i].cloneNode(true);

		for (i=0; i < newHosts.length; i++) { 
			newRoot.appendChild(hFile.createTextNode("\n")); 
			newRoot.appendChild(newHosts[i]); 
			newRoot.appendChild(hFile.createTextNode("\n")); 
			}
		hFile.removeChild(hFile.firstChild);
		hFile.appendChild(newRoot);

		var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
		persist.persistFlags = persist.PERSIST_FLAGS_NO_CONVERSION | persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES | persist.PERSIST_FLAGS_BYPASS_CACHE;
		persist.saveDocument(hFile, this.hostFile, null, null, null, null);
	},

	getHosts : function host_getHosts() {
		if( !this.hostFile.exists() ) return null;

		var fileURI = ioService.newFileURI(this.hostFile);

		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);
		
		return req.responseXML;
		},

	getHostf_servers : function() {
		if( !this.hostf_servers.exists() ) return null;

		var fileURI = ioService.newFileURI(this.hostf_servers);

		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);
		
		return req.responseXML;
		}

	}

function sortHosts() {
	var tmpList = new Array();

	for (i=0; i < hosts.length; i++)
		tmpList[i] = hosts[i].getAttribute("id");

	tmpList = tmpList.sort();

	for (i = 0; i < tmpList.length; i++) {
		for (j = 0; j < hosts.length; j++) {
			if (tmpList[i] == hosts[j].getAttribute("id")) {
				tmpList[i] = hosts[j].cloneNode(true);
				break;
				}
			}
		}

	for (i = 0; i < tmpList.length; i++) {
		hFile.firstChild.replaceChild(tmpList[i], hosts[i]);
		}
	}

function initWindow() {
	window.addEventListener("resize", resizeResponseTextBox, false);
	//resizeResponseTextBox();
	loadHostFile();
	}

function resizeResponseTextBox() {
	var rBoxThing = document.getElementById("tb_searchPattern");
	rBoxThing.height = window.innerHeight - 212;
	}

function loadHostFile() {
	hostFileLoc = prefManager.getCharPref("extensions.imagegrabber.hostfileloc");

	hostFileObj = new HostFileService();
	hFile = hostFileObj.getHosts();
	hosts = hFile.getElementsByTagName("host");

	sortHosts();

	document.getElementById("tb_hostFileLoc").value = hostFileObj.hostFile.path;

	var menu_popup = document.getElementById("theList");
	menu_popup.removeAllItems();

	for (i=0; i < hosts.length; i++) {
		var newElem = menu_popup.appendItem(hosts[i].getAttribute("id"), i);
		//newElem.setAttribute("onclick", "fillTBs(this.value);");
		newElem.setAttribute("oncommand", "fillTBs(this.value);");
		}
	}

function fillTBs(idx) {
	var uPatNode = hosts[idx].getElementsByTagName("urlpattern")[0];
	var uPat = uPatNode.textContent;
	var sPatNode = hosts[idx].getElementsByTagName("searchpattern")[0];
	var sPat = sPatNode.textContent;

	var hl_tbout = document.getElementById("tb_hostLabel");
	hl_tbout.value = hosts[idx].getAttribute("id");

	var up_tbout = document.getElementById("tb_urlPattern");
	up_tbout.value = uPat;

	var sp_tbout = document.getElementById("tb_searchPattern");
	if(!sPat.match(/function/)) sp_tbout.value = sPat.replace("\\\\", "\\", "g");
	else sp_tbout.value = sPat;
	}

function updateHostFile() {
	var urlPattern = document.getElementById("tb_urlPattern").value;
	var searchPattern = document.getElementById("tb_searchPattern").value;
	if (!searchPattern.match(/function/)) searchPattern = searchPattern.replace(/\\(?!\")/g, "\\\\");
	var label = document.getElementById("tb_hostLabel").value;
	var menupopup = document.getElementById("theList");
	var idx = menupopup.value;

	hosts[idx].setAttribute("id", label);

	var uPatNode = hosts[idx].getElementsByTagName("urlpattern")[0];
	uPatNode.textContent = urlPattern;

	var sPatNode = hosts[idx].getElementsByTagName("searchpattern")[0];
	sPatNode.textContent = searchPattern;

	sortHosts();

	hostFileObj.writeHosts();

	loadHostFile();

	//document.getElementById("theList").setAttribute("label", label);
	for (var i = 0; i < menupopup.itemCount; i++) { 
		var zha = menupopup.getItemAtIndex(i);
		if (zha.label == label) { 
			menupopup.selectedIndex = i;
			fillTBs(i);
			break;
			}
		}
	}

function addHost() {
	var urlPattern = document.getElementById("tb_urlPattern").value;
	var searchPattern = document.getElementById("tb_searchPattern").value;
	if (!searchPattern.match(/function/)) searchPattern = searchPattern.replace(/\\(?!\")/g, "\\\\");
	var label = document.getElementById("tb_hostLabel").value;
	var menupopup = document.getElementById("theList");

	var newHost = hFile.createElement("host");
	newHost.setAttribute("id", label);

	var newUP = hFile.createElement("urlpattern");
	newUP.textContent = urlPattern;

	var newSP = hFile.createElement("searchpattern");
	if (searchPattern.match(/function/)) {
		var cData = hFile.createCDATASection(searchPattern);
		newSP.appendChild(cData);
		}
	else newSP.textContent = searchPattern;

	newHost.appendChild(hFile.createTextNode("\n"));
	newHost.appendChild(newUP);
	newHost.appendChild(hFile.createTextNode("\n"));
	newHost.appendChild(newSP);
	newHost.appendChild(hFile.createTextNode("\n"));

	hFile.firstChild.appendChild(newHost);
	hFile.firstChild.appendChild(hFile.createTextNode("\n\n"));

	sortHosts();

	hostFileObj.writeHosts();

	loadHostFile();

	//document.getElementById("theList").setAttribute("label", label);
	for (var i = 0; i < menupopup.itemCount; i++) { 
		var zha = menupopup.getItemAtIndex(i);
		if (zha.label == label) { 
			menupopup.selectedIndex = i;
			fillTBs(i);
			break;
			}
		}
	}

function deleteHost() {
	var idx = document.getElementById("theList").value;

	hFile.firstChild.removeChild(hosts[idx]);
	hostFileObj.writeHosts();

	loadHostFile();

	document.getElementById("theList").setAttribute("label", "Select host...");
	document.getElementById("tb_urlPattern").value = "";
	document.getElementById("tb_searchPattern").value = "";
	document.getElementById("tb_hostLabel").value = "";
	}


function changeHostFile() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);


	var FpTitle="Pick a Host File";
		
	fp.init(top.window, FpTitle, nsIFilePicker.modeOpen);
	var res = fp.show();

	if (res == nsIFilePicker.returnOK) {
 		if (fp.file && (fp.file.path.length > 0)) {
			prefManager.setCharPref("extensions.imagegrabber.hostfileloc", fp.file.path);
			loadHostFile();
			document.getElementById("theList").setAttribute("label", "Select host...");
			document.getElementById("tb_hostLabel").value = "";
			document.getElementById("tb_urlPattern").value = "";
			document.getElementById("tb_searchPattern").value = "";
			}
 		}
	}

function onlineHostF() {
	var serverList = hostFileObj.getHostf_servers();
	var servers = serverList.getElementsByTagName("server");

	for (var i=0; i < servers.length; i++) {
		var someUrl = servers[i].textContent;

		var req = new XMLHttpRequest();

		req.open("GET", someUrl, false);
		req.overrideMimeType('text/xml');
		req.send(null);
		var blah = mergeHostFile(req.responseXML);
		}
	}


function mergeHostFile(onlineXML) {
	if (!onlineXML) {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);


		var FpTitle="Pick a Host File";
		
		fp.init(top.window, FpTitle, nsIFilePicker.modeOpen);
		var res = fp.show();

		if (res != nsIFilePicker.returnOK) return false;
		if (!fp.file) return false;
		if (!(fp.file.path.length > 0)) return false;

		var fileURI = ioService.newFileURI(fp.file);
		var req = new XMLHttpRequest();
		req.open("GET", fileURI.spec, false);
		req.send(null);

		var mergFile = req.responseXML;
		}
	else mergFile = onlineXML;

	var mergHosts = mergFile.getElementsByTagName("host");

	var tmpList = new Array();

	for (var i=0; i < mergHosts.length; i++)
		tmpList[i] = mergHosts[i].getAttribute("id");

	tmpList = tmpList.sort();

	for (var i = 0; i < tmpList.length; i++) {
		for (var j = 0; j < mergHosts.length; j++) {
			if (tmpList[i] == mergHosts[j].getAttribute("id")) {
				tmpList[i] = mergHosts[j].cloneNode(true);
				break;
				}
			}
		}

	for (var i = 0; i < tmpList.length; i++)
		mergFile.firstChild.replaceChild(tmpList[i], mergHosts[i]);

	var overWriteMode = confirm("About to enter overwrite mode.  Click cancel to add only new hosts.");
			
	for (var i=0; i < mergHosts.length; i++) {
		for (var j=0; j < hosts.length; j++) {
			if (mergHosts[i].getAttribute("id") == hosts[j].getAttribute("id")) {
				if (overWriteMode) hFile.firstChild.removeChild(hosts[j]);
				else { mergFile.firstChild.removeChild(mergHosts[i]); i--; }
				break;
				}
			}
		}


	for (var i=0; i < mergHosts.length; i++) {
		// This rule is not strictly enforced.
		// But, it ensures the owner document is proper
		var tmpNode = hFile.importNode(mergHosts[i], true);
		hFile.firstChild.appendChild(tmpNode);
		}

	sortHosts();
	hostFileObj.writeHosts();

	loadHostFile();
	document.getElementById("theList").setAttribute("label", "Select host...");
	document.getElementById("tb_hostLabel").value = "";
	document.getElementById("tb_urlPattern").value = "";
	document.getElementById("tb_searchPattern").value = "";

	return true;
	}


function resetHostFileLoc() {
	prefManager.setCharPref("extensions.imagegrabber.hostfileloc", "");
	loadHostFile();
}

