/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




/* partialMatch function:  This function returns a partial match of a string
 * inside another string.  More will be revealed
 */
function partialMatch(baseText, targetText) {
	var returnString = new Object();
	returnString.matchString = "";
	returnString.percentMatch = 0;

	//forward search
	for (var i = 0; i < baseText.length; i++ ) {
		var partialText = baseText.substring(i);

		/* the below is a little extreme, but, in ensures that
		 * RegExp does not interpret any characters as anything
		 * but literal characters.
		 */
		partialText = partialText.replace(/([\\\^\$\*\+\?\.\(\)\|\{\}])/g, "\\$1");

		re = new RegExp(partialText, "m")
		if ( targetText.match(re) ) {
			returnString.matchString = partialText;
			returnString.percentMatch = (partialText.length / baseText.length) * 100;
			i = baseText.length;
			}

		} //end of for

	var tempString = returnString;

	//reverse search
	for (var i = baseText.length; i > 0; i-- ) {
		var partialText = baseText.substring(0, i);

		partialText = partialText.replace(/([\\\^\$\*\+\?\.\(\)\|\{\}])/g, "\\$1");

		re = new RegExp(partialText, "m")
		if ( targetText.match(re) ) {
			returnString.matchString = partialText;
			returnString.percentMatch = (partialText.length / baseText.length) * 100;
			i = 0;
			}

		} //end of for

	if (tempString.percentMath >= returnString.percentMatch) returnString = tempString;

	return returnString;
	} //end of function







function all_escape(sometext) {
	var tmp_string = escape(sometext);
	tmp_string = tmp_string.replace(/\*/g, "%2A");
	tmp_string = tmp_string.replace(/@/g, "%40");
	tmp_string = tmp_string.replace(/-/g, "%2D");
	tmp_string = tmp_string.replace(/_/g, "%5F");
	tmp_string = tmp_string.replace(/\+/g, "%2B");
	tmp_string = tmp_string.replace(/\./g, "%2E");
	tmp_string = tmp_string.replace(/\//g, "%2F");

	return tmp_string;
	}


// This will save the pageData straight to a file if it is known to be an image.
function doSaveToFile(reqObj, stuffToSave) {
	var pic_uri = ioService.newURI(req.reqURL,null,null);
	var pic_url = pic_uri.QueryInterface(Components.interfaces.nsIURL);

	var fileName = pic_url.fileName;


	var f_perms = 0755;  // this is ignored on windows
	var f_flags = 0x02 | 0x08;
	f_flags |= 0x20;

	var count = stuffToSave.length;

	var fout = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var aLocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	aLocalFile.initWithPath(req.dirSave);
	aLocalFile.append(fileName);

	fout.init(aLocalFile, f_flags, f_perms, null);
		
	fout.write(stuffToSave, count);
	fout.close();
}